Package org.eclipse.cdt.core.build

# Class ErrorBuildConfiguration

java.lang.Object
org.eclipse.core.runtime.PlatformObject
org.eclipse.cdt.core.build.ErrorBuildConfiguration

All Implemented Interfaces:
  `ICBuildConfiguration`, `ICBuildConfiguration2`, `IScannerInfoProvider`, `org.eclipse.core.runtime.IAdaptable`

public class ErrorBuildConfiguration extends org.eclipse.core.runtime.PlatformObject implements ICBuildConfiguration, ICBuildConfiguration2
A Build configuration that simply spits out an error message on the console at build and clean time. Used to signify that we're not sure how to build this project in it's current state. TODO leaving most of the implementation as default. I don't think any of these methods get called when we're in this error state but we'll keep an eye open for NPE's and bad behavior.

Since:
  6.9

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`NAME`
`static final org.eclipse.cdt.core.build.ErrorBuildConfiguration.Provider`
`PROVIDER`

### Fields inherited from interface org.eclipse.cdt.core.build.ICBuildConfiguration

`TOOLCHAIN_ID, TOOLCHAIN_TYPE`

## Constructor Summary

Constructors
Constructor
Description
`ErrorBuildConfiguration(org.eclipse.core.resources.IBuildConfiguration config, String errorMessage)`

## Method Summary

Modifier and Type
Method
Description
`org.eclipse.core.resources.IProject[]`
`build(int kind, Map<String,String> args, IConsole console, org.eclipse.core.runtime.IProgressMonitor monitor)`
Perform the build.
`void`
`clean(IConsole console, org.eclipse.core.runtime.IProgressMonitor monitor)`
Perform clean.
`List<String>`
`getBinaryParserIds()`
Ids for the Binary Parsers to use when checking whether a file is a binary that can be launched.
`org.eclipse.core.resources.IBuildConfiguration`
`getBuildConfiguration()`
Returns the resources build configuration that this CDT build configuration is associated with.
`URI`
`getBuildDirectoryURI()`
The URI for the directory in which the build is executed.
`IScannerInfo`
`getScannerInformation(org.eclipse.core.resources.IResource resource)`
The receiver will answer the current state of the build information for the resource specified in the argument.
`IToolChain`
`getToolChain()`
Build Configurations are configurations for a given toolchain.
`IEnvironmentVariable`
`getVariable(String name)`
Return a build environment variable with a given name.
`IEnvironmentVariable[]`
`getVariables()`
Return all of the build environment variables for this configuration.
`void`
`setActive()`
Mark the Build Configuration as active
`void`
`setErrorMessage(String errorMessage)`
`void`
`subscribe(org.eclipse.core.resources.IResource resource, IScannerInfoChangeListener listener)`
The receiver will register the listener specified in the argument to receive change notifications when the information for the `IResource` it is responsible for changes.
`void`
`unsubscribe(org.eclipse.core.resources.IResource resource, IScannerInfoChangeListener listener)`
The receiver will no longer notify the listener specified in the argument when information about the reource it is responsible for changes.

### Methods inherited from class org.eclipse.core.runtime.PlatformObject

`getAdapter`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.eclipse.core.runtime.IAdaptable

`getAdapter`

### Methods inherited from interface org.eclipse.cdt.core.build.ICBuildConfiguration

`getBuildOutput, getDefaultProperties, getLaunchMode, getLaunchTarget, getProperties, getProperty, removeProperty, setBuildEnvironment, setProperties, setProperty, supportsProperties`

## Field Details

### NAME

public static final String NAME

See Also:
  - Constant Field Values

### PROVIDER

public static final org.eclipse.cdt.core.build.ErrorBuildConfiguration.Provider PROVIDER

## Constructor Details

### ErrorBuildConfiguration

public ErrorBuildConfiguration(org.eclipse.core.resources.IBuildConfiguration config, String errorMessage)

## Method Details

### setErrorMessage

public void setErrorMessage(String errorMessage)

### build

public org.eclipse.core.resources.IProject[] build(int kind, Map<String,String> args, IConsole console, org.eclipse.core.runtime.IProgressMonitor monitor) throws org.eclipse.core.runtime.CoreException
Description copied from interface: `ICBuildConfiguration`
Perform the build.

Specified by:
  `build` in interface `ICBuildConfiguration`
Parameters:
  `kind` - build type
  `args` - build arguments
  `console` - console to show build output
  `monitor` - progress monitor
Returns:
  the list of projects for which this builder would like deltas the next time it is run or `null` if none
Throws:
  `org.eclipse.core.runtime.CoreException`

### clean

public void clean(IConsole console, org.eclipse.core.runtime.IProgressMonitor monitor) throws org.eclipse.core.runtime.CoreException
Description copied from interface: `ICBuildConfiguration`
Perform clean.

Specified by:
  `clean` in interface `ICBuildConfiguration`
Parameters:
  `console` - console to show clean output
  `monitor` - progress monitor
Throws:
  `org.eclipse.core.runtime.CoreException`

### getScannerInformation

public IScannerInfo getScannerInformation(org.eclipse.core.resources.IResource resource)
Description copied from interface: `IScannerInfoProvider`
The receiver will answer the current state of the build information for the resource specified in the argument.

Specified by:
  `getScannerInformation` in interface `IScannerInfoProvider`

### subscribe

public void subscribe(org.eclipse.core.resources.IResource resource, IScannerInfoChangeListener listener)
Description copied from interface: `IScannerInfoProvider`
The receiver will register the listener specified in the argument to receive change notifications when the information for the `IResource` it is responsible for changes.

Specified by:
  `subscribe` in interface `IScannerInfoProvider`
Parameters:
  `listener` -

### unsubscribe

public void unsubscribe(org.eclipse.core.resources.IResource resource, IScannerInfoChangeListener listener)
Description copied from interface: `IScannerInfoProvider`
The receiver will no longer notify the listener specified in the argument when information about the reource it is responsible for changes.

Specified by:
  `unsubscribe` in interface `IScannerInfoProvider`
Parameters:
  `listener` -

### setActive

public void setActive()
Description copied from interface: `ICBuildConfiguration2`
Mark the Build Configuration as active

Specified by:
  `setActive` in interface `ICBuildConfiguration2`

### getBuildDirectoryURI

public URI getBuildDirectoryURI() throws org.eclipse.core.runtime.CoreException
Description copied from interface: `ICBuildConfiguration2`
The URI for the directory in which the build is executed.

Specified by:
  `getBuildDirectoryURI` in interface `ICBuildConfiguration2`
Throws:
  `org.eclipse.core.runtime.CoreException`

### getBuildConfiguration

public org.eclipse.core.resources.IBuildConfiguration getBuildConfiguration() throws org.eclipse.core.runtime.CoreException
Description copied from interface: `ICBuildConfiguration`
Returns the resources build configuration that this CDT build configuration is associated with.

Specified by:
  `getBuildConfiguration` in interface `ICBuildConfiguration`
Returns:
  resources build configuration
Throws:
  `org.eclipse.core.runtime.CoreException`

### getToolChain

public IToolChain getToolChain() throws org.eclipse.core.runtime.CoreException
Description copied from interface: `ICBuildConfiguration`
Build Configurations are configurations for a given toolchain.

Specified by:
  `getToolChain` in interface `ICBuildConfiguration`
Returns:
  the toolchain for this build configuration
Throws:
  `org.eclipse.core.runtime.CoreException`

### getVariable

public IEnvironmentVariable getVariable(String name) throws org.eclipse.core.runtime.CoreException
Description copied from interface: `ICBuildConfiguration`
Return a build environment variable with a given name.

Specified by:
  `getVariable` in interface `ICBuildConfiguration`
Parameters:
  `name` - build environment variable name
Returns:
  value of the build environment variable.
Throws:
  `org.eclipse.core.runtime.CoreException`

### getVariables

public IEnvironmentVariable[] getVariables() throws org.eclipse.core.runtime.CoreException
Description copied from interface: `ICBuildConfiguration`
Return all of the build environment variables for this configuration.

Specified by:
  `getVariables` in interface `ICBuildConfiguration`
Returns:
  environment variables
Throws:
  `org.eclipse.core.runtime.CoreException`

### getBinaryParserIds

public List<String> getBinaryParserIds() throws org.eclipse.core.runtime.CoreException
Description copied from interface: `ICBuildConfiguration`
Ids for the Binary Parsers to use when checking whether a file is a binary that can be launched.

Specified by:
  `getBinaryParserIds` in interface `ICBuildConfiguration`
Returns:
  binary parser ids
Throws:
  `org.eclipse.core.runtime.CoreException`